use strict;
use warnings;
use File::Basename;

my @want = qw/48 44 52 00 00 00 00 00/;
my %xor_val = map {$_ => 1} (0..9, 'a'..'f');
my @key = ();


if(scalar @ARGV < 1)
{
    print "Usage: ".basename($0)." file.vis";
    exit;
}

open A, '<', $ARGV[0] or die $!;
read A, my $data, 8 + 16 + 16;
close A;

if(substr $data, 0, 4 eq 'VIS3')
{
    print "Invalid signature (expected VIS3)\n";
    exit;
}

my @data = split //, substr $data, 8, 8;
for(my $i = 0; $i < scalar @data; $i++)
{
    my $byte = hex $want[$i] ^ ord $data[$i];
    push @key, $xor_val{chr $byte} ? chr $byte : '?';
}

my @data_xor = ();
@data = split //, substr $data, 8 + 16, 8;
for(my $i = 4; $i < scalar @data; $i++)
{
    push @data_xor, chr (ord $data[$i] ^ ord $key[$i % scalar @key]);
}

my $offset = hex unpack 'H8', join '', @data_xor;
my $i_value1 = hex unpack 'H8', join '', substr $data, 8 + 8, 4;
my $i_value2 = hex unpack 'H8', join '', substr $data, 8 + 8 + 4, 4;

my $k_value1 = $offset ^ $i_value1;
my $k_value2 = $offset ^ $i_value2;

push @key, pack 'N', $k_value1;
push @key, pack 'N', $k_value2;

print @key;
